// flatpickr dependency

flatpickr("#calendar-picker", {
    "locale": "ru",
    inline: true,
    altInput: true,
    altFormat: "j F Y",
    dateFormat: "Y-m-d",
    plugins: [
        ShortcutButtonsPlugin({
          button: [
            {
              label: "Сегодня"
            }
          ],
          onClick: (index, fp) => {
            let date = new Date();
            fp.setDate(date);
          }
        })
      ]
});


// CSS

document.querySelector(".tabs").style.display = "none";
document.querySelector(".content").style.display = "none";

document.querySelector(".start-page-ready-button").onclick = function timetable_screen() {
  document.querySelector(".timetable-tab").classList.add("active");
  document.querySelector(".grade-tab").classList.remove("active");
  document.querySelector(".settings-tab").classList.remove("active");
  document.querySelector(".start-page").style.display = "none";
  document.querySelector(".tabs").style.display = "flex";
  document.querySelector(".content").style.display = "flex";
  document.querySelector(".timetable").style.display = "flex";
  document.querySelector(".grade").style.display = "none";
  document.querySelector(".settings").style.display = "none";
}

document.querySelector(".timetable-tab").onclick = function active_timetable() {
  document.querySelector(".timetable-tab").classList.add("active");
  document.querySelector(".grade-tab").classList.remove("active");
  document.querySelector(".settings-tab").classList.remove("active");
  document.querySelector(".timetable").style.display = "flex";
  document.querySelector(".grade").style.display = "none";
  document.querySelector(".settings").style.display = "none";
}

document.querySelector(".grade-tab").onclick = function active_grade() {
  document.querySelector(".grade-tab").classList.add("active");
  document.querySelector(".timetable-tab").classList.remove("active");
  document.querySelector(".settings-tab").classList.remove("active");
  document.querySelector(".grade").style.display = "flex";
  document.querySelector(".timetable").style.display = "none";
  document.querySelector(".settings").style.display = "none";
}

document.querySelector(".settings-tab").onclick = function active_settings() {
  document.querySelector(".settings-tab").classList.add("active");
  document.querySelector(".timetable-tab").classList.remove("active");
  document.querySelector(".grade-tab").classList.remove("active");
  document.querySelector(".settings").style.display = "flex";
  document.querySelector(".timetable").style.display = "none";
  document.querySelector(".grade").style.display = "none";
}

document.querySelector(".reset-button").onclick = function reset_settings() {
  document.querySelector(".tabs").style.display = "none";
  document.querySelector(".content").style.display = "none";
  document.querySelector(".start-page").style.display = "";
}

document.querySelector(".btn").setAttribute("role", "button");
document.querySelector(".btn").setAttribute("aria-pressed", "false");
document.querySelector(".btn").setAttribute("tabindex", "0");


// create lesson cards

// window.addEventListener("DOMContentLoaded", () => {

//   function req() {


//     fetch("http://127.0.0.1:5500/data/timetable.json")
//         .then(data => data.json())
//         .then(data => console.log(data))
//         .then(data => createLessons(data))
//         .catch(err => console.error(err));

//   }

//   function createLessons(response) {
//     response.forEach(item => {
//       let lesson-card = document.createElement("lesson-card");
//       lesson-card.classList.add("lesson-card");

//       card.innerHTML += `
//         <div class="start-time">${item.startTime}</div>
//       `;

//       document.querySelector(".lessons-list").appendChild(lesson-card);
//     });
//   }

//   req();

// });





// add test timetable data

function createTimetableFirst() {
  let firstLesson = document.createElement("div");
  firstLesson.classList.add("first-lesson");
  firstLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        9:40
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        11:10
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Информационные технологии и системы бизнес-аналитики
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Лабораторная
        </div>
        <div class="subject-teacher">
          Атаян Ануш Михайловна
        </div>
      </div>
      <div class="address-or-distance">
        Дистанционное обучение
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(firstLesson);

  let secondLesson = document.createElement("div");
  secondLesson.classList.add("second-lesson");
  secondLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        13:30
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        15:00
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Физическая культура и спорт (элективная дисциплина)
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Практическая
        </div>
        <div class="subject-teacher">
          Головко Андрей Александрович
        </div>
      </div>
      <div class="address-or-distance">
        Мойка 48, корп. 4, ауд. 1
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(secondLesson);
}


function createTimetableSecond() {
  let firstLesson = document.createElement("div");
  firstLesson.classList.add("first-lesson");
  firstLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        11:20 
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        12:50
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Программирование
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Лекция
        </div>
        <div class="subject-teacher">
          Жуков Николай Николаевич
        </div>
      </div>
      <div class="address-or-distance">
        Дистанционное обучение
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(firstLesson);

  let secondLesson = document.createElement("div");
  secondLesson.classList.add("second-lesson");
  secondLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        13:30
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        15:00
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Основы корпоративного электронного обучения
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Практическая
        </div>        
        <div class="subject-teacher">
          Власова Елена Зотиковна
        </div>
      </div>
      <div class="address-or-distance">
        Мойка 48, корп. 1, ауд. 335
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(secondLesson);

  let thirdLesson = document.createElement("div");
  thirdLesson.classList.add("third-lesson");
  thirdLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        15:10
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        16:40
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Электроника
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Лекция
        </div>        
        <div class="subject-teacher">
          Жаркой Александр Борисович
        </div>
      </div>
      <div class="address-or-distance">
        Мойка 48, корп. 1, ауд. 237
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(thirdLesson);

}


function createTimetableThird() {
  let firstLesson = document.createElement("div");
  firstLesson.classList.add("first-lesson");
  firstLesson.innerHTML = `
    <div class="time">
      <div class="start-time">
        16:50 
      </div>
      <div class="time-divider">
        —
      </div>
      <div class="end-time">
        18:20
      </div>
    </div>
    <div class="about-subject">
      <div class="subject-name">
        Основы электронного управления
      </div>
      <div class="subject-type-and-teacher">
        <div class="subject-type">
          Лабораторная
        </div>
        <div class="subject-teacher">
          Иванова Екатерина Алексеевна
        </div>
      </div>
      <div class="address-or-distance">
        Дистанционное обучение
      </div>
    </div>
  `;
  document.querySelector(".lessons-list").appendChild(firstLesson);

}


function clearTimetable() {
  document.querySelectorAll(".first-lesson").forEach(e => e.remove());
  document.querySelectorAll(".second-lesson").forEach(e => e.remove());
  document.querySelectorAll(".third-lesson").forEach(e => e.remove());
}


firstDataArray = ["2022-06-02", "2022-06-06", "2022-06-09", "2022-06-13", "2022-06-16", "2022-06-20", "2022-06-23", "2022-06-27", "2022-06-30"]
secondDataArray = ["2022-06-03", "2022-06-07", "2022-06-10", "2022-06-14", "2022-06-17", "2022-06-21", "2022-06-24", "2022-06-28"]
thirdDataArray = ["2022-06-01", "2022-06-04", "2022-06-08", "2022-06-11", "2022-06-15", "2022-06-18", "2022-06-22", "2022-06-25", "2022-06-29"]
weekendDataArray = ["2022-06-05", "2022-06-12", "2022-06-18", "2022-06-19", "2022-06-26"]


let pickedDate = document.querySelector("#calendar-picker");

let todayDate = new Date().toISOString().slice(0,10);
pickedDate.value = todayDate;
document.querySelector(".form-control").value = todayDate;

if (firstDataArray.includes(pickedDate.value)) {
  clearTimetable();
  createTimetableFirst();
}

else if (secondDataArray.includes(pickedDate.value)) {
  clearTimetable();
  createTimetableSecond();
}

else if (thirdDataArray.includes(pickedDate.value)) {
  clearTimetable();
  createTimetableThird();
}

else if (weekendDataArray.includes(pickedDate.value)) {
  clearTimetable();
  createTimetableWeekend();
}


pickedDate.addEventListener("change", (e) => {

  if (firstDataArray.includes(e.target.value)) {
    clearTimetable();
    createTimetableFirst();
  }

  else if (secondDataArray.includes(e.target.value)) {
    clearTimetable();
    createTimetableSecond();
  }

  else if (thirdDataArray.includes(e.target.value)) {
    clearTimetable();
    createTimetableThird();
  }

  else if (weekendDataArray.includes(e.target.value)) {
    clearTimetable();
    createTimetableWeekend();
  }
});


// fix today button

document.querySelector(".shortcut-buttons-flatpickr-button").addEventListener("click", (e) => {
  if (firstDataArray.includes(todayDate)) {
    clearTimetable();
    createTimetableFirst();
  }

  else if (secondDataArray.includes(todayDate)) {
    clearTimetable();
    createTimetableSecond();
  }

  else if (thirdDataArray.includes(todayDate)) {
    clearTimetable();
    createTimetableThird();
  }

  else if (weekendDataArray.includes(todayDate)) {
    clearTimetable();
    createTimetableWeekend();
  }
});



// add test grade data


function createGradeFirst() {
  let firstGrade = document.createElement("div");
  firstGrade.classList.add("grade-card");
  firstGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Естественно-математический". Математика
    </div>
    <div class="grade-date">
      08.12.2020
    </div>
    <div class="grade-mark five-or-credited">
      Зачтено (Отлично)
    </div>
  `;
  document.querySelector(".grade-list").appendChild(firstGrade);

  let secondGrade = document.createElement("div");
  secondGrade.classList.add("grade-card");
  secondGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Системное и прикладное программное обеспечение". Программирование
    </div>
    <div class="grade-date">
      17.12.2020
    </div>
    <div class="grade-mark five-or-credited">
      Отлично
    </div>
  `;
  document.querySelector(".grade-list").appendChild(secondGrade);

  let thirdGrade = document.createElement("div");
  thirdGrade.classList.add("grade-card");
  thirdGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Информационные технологии в математике и физике". Информационные технологии
    </div>
    <div class="grade-date">
      22.12.2020
    </div>
    <div class="grade-mark four">
      Хорошо
    </div>
  `;
  document.querySelector(".grade-list").appendChild(thirdGrade);
}


function createGradeSecond() {
  let firstGrade = document.createElement("div");
  firstGrade.classList.add("grade-card");
  firstGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Организация ЭВМ". ЭВМ и периферийные устройства
    </div>
    <div class="grade-date">
      19.06.2021
    </div>
    <div class="grade-mark three">
      Зачтено (Удовлетв.)
    </div>
  `;
  document.querySelector(".grade-list").appendChild(firstGrade);

  let secondGrade = document.createElement("div");
  secondGrade.classList.add("grade-card");
  secondGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Экономикo-правовой". Правоведение
    </div>
    <div class="grade-date">
      18.06.2021
    </div>
    <div class="grade-mark four">
      Зачтено (Хорошо)
    </div>
  `;
  document.querySelector(".grade-list").appendChild(secondGrade);

  let thirdGrade = document.createElement("div");
  thirdGrade.classList.add("grade-card");
  thirdGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Информационные технологии в управлении в IT-компании". IT-менеджмент
    </div>
    <div class="grade-date">
      01.07.2021
    </div>
    <div class="grade-mark three">
      Удовлетв.
    </div>
  `;
  document.querySelector(".grade-list").appendChild(thirdGrade);

  let fourthGrade = document.createElement("div");
  fourthGrade.classList.add("grade-card");
  fourthGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Системное и прикладное программное обеспечение". Базы данных
    </div>
    <div class="grade-date">
      25.06.2021
    </div>
    <div class="grade-mark five-or-credited">
      Отлично
    </div>
  `;
  document.querySelector(".grade-list").appendChild(fourthGrade);

  let fifthGrade = document.createElement("div");
  fifthGrade.classList.add("grade-card");
  fifthGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Информационные технологии в управлении в IT-компании". IT-менеджмент
    </div>
    <div class="grade-date">
      01.07.2021
    </div>
    <div class="grade-mark three">
      Удовлетв.
    </div>
  `;
  document.querySelector(".grade-list").appendChild(fifthGrade);
}

function createGradeThird() {
  let firstGrade = document.createElement("div");
  firstGrade.classList.add("grade-card");
  firstGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Экономикo-правовой". Правоведение	
    </div>
    <div class="grade-date">
      08.12.2021
    </div>
    <div class="grade-mark five-or-credited">
      Зачтено
    </div>
  `;
  document.querySelector(".grade-list").appendChild(firstGrade);

  let secondGrade = document.createElement("div");
  secondGrade.classList.add("grade-card");
  secondGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Информационные ресурсы и средства профессиональной деятельности инженера". Практикум по программированию
    </div>
    <div class="grade-date">
      17.12.2021
    </div>
    <div class="grade-mark">
      
    </div>
  `;
  document.querySelector(".grade-list").appendChild(secondGrade);

  let thirdGrade = document.createElement("div");
  thirdGrade.classList.add("grade-card");
  thirdGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Информационные технологии в управлении в IT-компании". IT-рекрутмент
    </div>
    <div class="grade-date">
      19.12.2021
    </div>
    <div class="grade-mark three">
      Удовлетв.
    </div>
  `;
  document.querySelector(".grade-list").appendChild(thirdGrade);

  let fourthGrade = document.createElement("div");
  fourthGrade.classList.add("grade-card");
  fourthGrade.innerHTML = `
    <div class="grade-subject-title">
      Модуль "Организация ЭВМ". Физические основы микроэлектроники
    </div>
    <div class="grade-date">
      14.12.2021
    </div>
    <div class="grade-mark two-or-uncredited">
      Незачтено
    </div>
  `;
  document.querySelector(".grade-list").appendChild(fourthGrade);

}


function clearGrade() {
  document.querySelectorAll(".grade-card").forEach(e => e.remove());
}


let pickedSemester = document.querySelector("#semester-picker");

if (pickedSemester.value == "third-semester") {
  createGradeThird();
}


pickedSemester.addEventListener("change", (e) => {
  console.log(e.target.value);

  if (e.target.value == "first-semester") {
    clearGrade();
    createGradeFirst();
  }

  else if (e.target.value == "second-semester") {
    clearGrade();
    createGradeSecond();
  }

  else if (e.target.value == "third-semester") {
    clearGrade();
    createGradeThird();
  }

});


const mediaQuery = window.matchMedia("(max-width: 480px)");

if (mediaQuery.matches) {
  let deleted_node = document.querySelectorAll("div.subject-type-and-teacher");
  let deleted_node_array = [...deleted_node];
  deleted_node_array.forEach(div => div.replaceWith(...div.childNodes));

  let div_list = document.querySelectorAll("div.grade-date");
  let div_array = [...div_list];
  div_array.forEach(div => {
    div.innerHTML = ``;
    div.replaceWith(...div.childNodes);
  });
  
  pickedDate.addEventListener("change", (e) => {
    let div_list = document.querySelectorAll("div.subject-type-and-teacher");
    let div_array = [...div_list];
    div_array.forEach(div => div.replaceWith(...div.childNodes))
  });
  
  document.querySelector(".shortcut-buttons-flatpickr-button").addEventListener("click", (e) => {
    let div_list = document.querySelectorAll("div.subject-type-and-teacher");
    let div_array = [...div_list];
    div_array.forEach(div => div.replaceWith(...div.childNodes))
  });
  
  pickedSemester.addEventListener("change", (e) => {
    let div_list = document.querySelectorAll("div.grade-date");
    let div_array = [...div_list];
    div_array.forEach(div => {
      div.innerHTML = ``;
      div.replaceWith(...div.childNodes);
    });
  });
}
